#pragma once
#include "iplugin.h"
#include <windows.h>
#include <set>

class TRenderExampleType :
	public IPKeyRenderType
{
	std::set<IPKeyRender*> Plugins;
public:
	TRenderExampleType(void);
	virtual ~TRenderExampleType(void);

	virtual const wchar_t*		GetPluginName(){ return L"ExampleRender";};
	virtual const wchar_t*		GetPluginCaption(){return L"Example rendering plugin";};

	virtual IPKeyRender*		CreateInstance(unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual void				FreeInstance(IPlugin* plg);
	virtual void				ShowPluginWindow(IPKeyRender* plg);
	HWND						GetGUI();
	void						RedrawControl();

	virtual void				Init(IAppControl* fb);
};

class TRenderExample :
	public IPKeyRender
{
protected:

public:
	TRenderExample(IPluginType* pt, unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual ~TRenderExample(void);

	virtual HWND GetPluginWindow();
	virtual void Draw(HDC dest, size_t key, unsigned int width, unsigned int height);

	virtual void RedrawGUI();

	virtual void Serialize(ISerializer* srlzr);
	virtual void Deserialize(const char* Data);
	virtual bool Animated(){return true;}
};

//---------------------------------------------------------------------------

class TConditionExampleType : public IPConditionType
{
	std::set<IPCondition*> Plugins;
public:
	TConditionExampleType();
	virtual ~TConditionExampleType();

	virtual const wchar_t*		GetPluginName(){ return L"ExampleCondition";};
	virtual const wchar_t*		GetPluginCaption(){return L"Example condition plugin";};

	virtual IPCondition*	CreateInstance(unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual void				FreeInstance(IPlugin* plg);
};

class TConditionExample : public IPCondition
{
	bool Active;
	HWND Window;
	HWND Button;
public:
	TConditionExample(IPluginType* pt, unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual ~TConditionExample();
	
	virtual HWND				GetPluginWindow() { return Window;}
	virtual void				RedrawGUI();
	virtual bool				IsActive();
	virtual void				HookTrigger(DWORD message, WPARAM wParam, LPARAM lParam);
	virtual void				SetBackgroundColor(COLORREF color);
};

//---------------------------------------------------------------------------

class TActionExampleType : public IPActionType
{
	std::set<IPAction*> Plugins;
public:
	TActionExampleType();
	virtual ~TActionExampleType();
	virtual const wchar_t*		GetPluginName(){ return L"ExampleAction";};
	virtual const wchar_t*		GetPluginCaption(){return L"Example action plugin";};
	virtual void				ShowPluginWindow(IPAction* plg);
	virtual IPAction*			CreateInstance(unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual void				FreeInstance(IPlugin* plg);
};

class TActionExample : public IPAction
{
public:
	TActionExample(IPluginType* pt, unsigned int Type, WPARAM Param, unsigned int OLED);
	virtual ~TActionExample();
	virtual void				Action(DWORD message, WPARAM wParam, LPARAM lParam);

	virtual HWND				GetPluginWindow() { return NULL;}			// no window
	virtual void				RedrawGUI(){};								// nothing to redraw

};

//---------------------------------------------------------------------------
